#
# $Id: amrita_wz_rd_publisher_test.rb,v 1.1 2004/01/17 12:02:26 hn Exp $
# Copyright Narushima Hironori. All rights reserved.
#

project_dir = File.dirname(__FILE__).sub(/(com.narucy.webpub.core).+/, '\1')
Dir.chdir project_dir
$: << project_dir + '/scripts/lib'

require 'ftools'
require 'test/unit'
require 'webpub/rftools'
require 'webpub/publisher'
require 'webpub/publish_manager'

=begin


=end
class AmritaWzRDPublisherTest < Test::Unit::TestCase

	def setup
		@proj_location = 'test_resources/webproject001'
		@tmpdir = ENV['TEMP'] + '/rd_publisher_test' + rand(999).to_s
		File.cp_all(@proj_location, @tmpdir)
		
		@config = ENV['TEMP'] + '/pubprop'
		open(@config, 'w') { |fh|
			fh << ['amrita_wz_rd', File.dirname(__FILE__) + '/amrita_wz_rd_publisher.rb', 'WebPub::AmritaWzRDPublisher'].join(',')
		}
		@curr_dir = Dir.pwd
		Dir.chdir(@tmpdir)
	end

	def test_publish_by_rd_with_tmpl
		manager = WebPub::PublishManager.new(@config)
		manager.publish( Dir.glob(@tmpdir + '/rd/with_tmpl/*.rd') )
		
		putfile = @tmpdir +'/public_html/pub_rd/amrita_wz_rd.html'
		lines = File.read(putfile)
		
		puts lines
		assert %r!<p>3rd RD.</p>! === lines
		assert %r!2002/2/2! === lines
	end

	def teardown
		Dir.chdir @curr_dir
		begin
			File.delete @config
			File.rm_all(@tmpdir)
		rescue
		end
	end

end
