#
# $Id: erb_publisher_test.rb,v 1.1 2004/01/17 12:02:27 hn Exp $
# Copyright Narushima Hironori. All rights reserved.
#

project_dir = File.dirname(__FILE__).sub(/(com.narucy.webpub.core).+/, '\1')
Dir.chdir project_dir
$: << project_dir + '/scripts/lib'

require 'test/unit'
require 'webpub/publisher'
require 'webpub/publish_manager'
require 'webpub/rftools'

=begin

=end
class ERBPublisherTest < Test::Unit::TestCase

	def setup
		@proj_location = 'test_resources/webproject001'
		@tmpdir = ENV['TEMP'] + '/amrita_publisher_test' + rand(999).to_s
		File.cp_all(@proj_location, @tmpdir)
	end

	def test_publish_by_erb
		config = ENV['TEMP'] + '/pubprop'
		begin
			open(config, 'w') { |fh|
				fh << ['erb', File.dirname(__FILE__) + '/erb_publisher.rb', 'WebPub::ERBPublisher'].join(',')
			}
			manager = WebPub::PublishManager.new(config)
			manager.publish( Dir.glob(@tmpdir + '/ht_sources/folder5/*.html') )
		ensure
			File.delete config
		end
		
		line = IO.readlines( @tmpdir + '/public_html/folder5/erb1.html').join
		assert %r!<h1>Home Page 1</h1>! === line
		assert %r!256\.! === line
		
		line = IO.readlines( @tmpdir + '/public_html/folder5/erb2.html').join
		assert %r!public_html/folder5/erb2.html\.! === line
		
		line = IO.readlines( @tmpdir + '/public_html/folder5/erb3.html').join
		assert %r!NilClass</pre>! === line
	end

	def teardown
		begin
			File.rm_all(@tmpdir)
		rescue
		end
	end

end
